<?php

require_once "abstract.ilPluginControllerFormGUI.php";
require_once "Customizing/global/plugins/Services/Repository/RepositoryObject/QuestionSetPool/classes/utils/class.ilQuestionSetPoolQuestionHeaderBuilder.php";


/**
 * Class ilQuestionSetPoolConditionGUI
 *
 * Date: 11.02.14
 * Time: 10:39
 * @author Thomas Joußen <tjoussen@databay.de>
 */
abstract class ilQuestionSetPoolConditionGUI extends ilPluginControllerFormGUI
{
    public function showPreview()
    {
        $gui = assQuestion::instantiateQuestionGUI((int) $_GET["question_id"]);
        $gui->setTargetGuiClass("ilObjQuestionSetPoolGUI");
        $gui->setQuestionHeaderBlockBuilder(new ilQuestionSetPoolQuestionHeaderBuilder($gui->object->getTitle));
        echo $gui->getPreview();
        exit;
    }

    /**
     *
     */
    public function afterQuestionChanged()
    {
        $template = new ilTemplate('tpl.il_xqsp_after_question_changed.html', false, false, 'Customizing/global/plugins/Services/Repository/RepositoryObject/QuestionSetPool');
        $this->tpl->setContent($template->get());
    }

    /**
     * @param ilQuestionSetPoolNode $model
     * @param ilTemplate $template
     */
    protected function renderQuestionInfo($model, $template)
    {
        $questions = $model->getPath()->getQuestionsLowerAndEqualsIndex($model->getIndex());

        $this->controller->populateContentStyleBlock();
        $this->controller->populateSyntaxStyleBlock();

        $mathJaxSetting = new ilSetting("MathJax");
        if ($mathJaxSetting->get("enable")) {
            $this->controller->tpl->addJavaScript($mathJaxSetting->get("path_to_mathjax"));
        }

        foreach ($questions as $key => $question_data) {
            $params = array(
                'node_id' => (int) $_GET['node_id'],
                'cmd' => get_class($this) . '.afterQuestionChanged'
            );
            $edit = 'ilias.php?consumer_context=' . base64_encode(json_encode($params)) . '&baseClass=ilObjQuestionPoolGUI&ref_id=' . $this->controller->object->getRefId() . '&cmd=editQuestionForTest&calling_consumer=' . $this->controller->object->getRefId() . '&q_id=' . $question_data["question_id"];

            $template->setCurrentBlock("question_row");
            $template->setVariable("CSS_ROW", "tblrow" . $key % 2);
            $template->setVariable("QUESTION_INDEX", "Q" . $question_data["question_index"]);
            $template->setVariable("QUESTION_ID", $question_data["question_id"]);
            $template->setVariable("PREVIEW", $this->lng->txt("preview"));
            $template->setVariable("EDIT_LINK", $edit);
            $template->setVariable("EDIT", $this->lng->txt("edit"));
            $template->setVariable("QUESTION_TITLE", $question_data["title"]);
            $template->parseCurrentBlock();
        }

        $template->setVariable("TXT_QUESTION", $this->controller->lng->txt('question'));
        $template->setVariable("TXT_ACTIONS", $this->controller->lng->txt('actions'));
        $template->setVariable("PREVIEW_LINK", $this->ctrl->getLinkTarget($this->controller, get_class($this) . ".showPreview", "", true));
        $template->setVariable('CLOSE_IMG_SRC', ilGlyphGUI::get(ilGlyphGUI::CLOSE));
        $template->setVariable('CLOSE_IMG_ALT', $this->controller->lng->txt('close'));
    }
}
