<?php

require_once "./Customizing/global/plugins/Services/Repository/RepositoryObject/QuestionSetPool/classes/models/abstract.ilPluginModelList.php";

/**
 * Class ilQuestionPoolQuestionList
 *
 * Date: 06.11.13
 * Time: 14:56
 * @author Thomas Joußen <tjoussen@databay.de>
 */
class ilQuestionPoolQuestionList extends ilPluginModelList
{

    /**
     * @var ilObjQuestionSetPool
     */
    protected $question_set_pool;

    /**
     * @param \ilObjQuestionSetPool $question_set_pool
     */
    public function setQuestionSetPool($question_set_pool)
    {
        $this->question_set_pool = $question_set_pool;
    }

    /**
     * @param array $params
     * @param array $filter
     *
     * @return array
     */
    public function loadData($params = array(), $filter = array())
    {
        require_once "./Customizing/global/plugins/Services/Repository/RepositoryObject/QuestionSetPool/classes/providers/class.ilQuestionSetPoolQuestionsBrowserProvider.php";

        $available_pools = array_keys(ilObjQuestionPool::_getAvailableQuestionpools(true, false, false, false, false));

        if (is_array($available_pools) && count($available_pools) == 0) {
            return null;
        }

        $filter["question_pools"] = $available_pools;
        $filter["xqsp_id"] = $this->question_set_pool->getId();

        $provider = new ilQuestionSetPoolQuestionsBrowserProvider();
        $data = $provider->loadData($filter, $params);

        return $data;
    }

    /**
     * @param array $data
     *
     * @return array
     */
    public function createObjectsFromData($data)
    {
        return $data;
    }
}
