<?php

require_once "abstract.ilPluginModelList.php";

/**
 * Class ilQuestionSetPoolPathList
 *
 * Date: 10.10.13
 * Time: 10:49
 * @author Thomas Joußen <tjoussen@databay.de>
 */
class ilQuestionSetPoolPathList extends ilPluginModelList
{
    /**
     * @var ilQuestionSetPoolSet
     */
    protected $set;

    public function __construct($set)
    {
        $this->set = $set;

        parent::__construct();
    }

    /**
     * @param array $params
     * @param array $filter
     *
     * @return array
     */
    public function loadData($params = array(), $filter = array())
    {
        require_once "./Customizing/global/plugins/Services/Repository/RepositoryObject/QuestionSetPool/classes/providers/class.ilQuestionSetPoolPathProvider.php";

        $provider = new ilQuestionSetPoolPathProvider();
        $filter["questionset_fi"] = $this->set->getId();
        return $provider->loadData($filter, $params);
    }

    public function update($data)
    {
        return $this->db->update(
            "rep_robj_xqsp_path",
            array(
                "path_index" => array("integer", $data["path_index"])
            ),
            array(
                "id" => array("integer", $data["id"])
            )
        );
    }

    public function getPath($id)
    {
        $data = $this->getData();

        foreach ($data as $item) {
            if ($item->getId() == $id) {
                return $item;
            }
        }

        return null;
    }

    public function insert($question_ids)
    {
        return true;
    }

    public function remove($question_ids)
    {
        return true;
    }

    /**
     * @param array $data
     *
     * @return array
     */
    public function createObjectsFromData($data)
    {
        return $data;
        /*$objects = array();
        foreach($data as $item)
        {
            require_once 'class.ilQuestionSetPoolSet.php';
            $set = new ilQuestionSetPoolSet($this->question_set_pool);
            $set->setId($item['id']);
            $set->setTitle($item['title']);
            $set->setDescription($item['description']);

            $objects[] = $set;
        }

        return $objects;*/
    }
}
