<?php

require_once "abstract.ilPluginTableDatabaseDataProvider.php";

/**
 * Class ilQuestionSetPoolSetQuestionsProvider
 *
 * Date: 15.11.13
 * Time: 10:01
 * @author Thomas Joußen <tjoussen@databay.de>
 */
class ilQuestionSetPoolSetQuestionsProvider extends ilPluginTableDatabaseDataProvider
{

    /**
     * @return string
     */
    protected function getSelectPart()
    {
        $fields = array(
            "qpl_questions.*",
            "qpl_qst_type.type_tag",
            "qpl_qst_type.plugin",
            "object_data.title as pool_title",
            "rep_robj_xqsp_qs_qst.question_index"
        );

        return implode(", ", $fields);
    }

    /**
     * @return string
     */
    protected function getFromPart()
    {
        $from = array(
            "qpl_questions",
        );

        return implode(", ", $from);
    }

    /**
     * @return string
     */
    protected function getJoinPart()
    {
        $joins = array(
            "INNER JOIN qpl_qst_type ON qpl_questions.question_type_fi = qpl_qst_type.question_type_id",
            "INNER JOIN object_data ON object_data.obj_id = qpl_questions.obj_fi",
            "LEFT JOIN rep_robj_xqsp_qs_qst ON rep_robj_xqsp_qs_qst.question_fi = qpl_questions.question_id"
        );

        return implode(" ", $joins);
    }

    /**
     * @param array $filter
     *
     * @return string
     */
    protected function getWherePart(array $filter)
    {
        $where = array(
            "qpl_questions.tstamp > 0",
            "rep_robj_xqsp_qs_qst.questionset_fi = " . $this->db->quote($filter["questionset_fi"], 'integer')
        );

        // ADD FILTER ELEMENTS

        return implode(" AND ", $where);
    }

    /**
     * @return string
     */
    protected function getGroupByPart()
    {
        return "";
    }

    /**
     * @param array $filter
     * @return string
     */
    protected function getHavingPart(array $filter)
    {
        return "";
    }

    /**
     * @param array $params
     * @return string
     */
    protected function getOrderByPart(array $params)
    {
        return "";
    }
}
