<?php

require_once "abstract.ilPluginTableDatabaseDataProvider.php";

/**
 * Class ilQuestionSetPoolSetsProvider
 *
 * Date: 07.10.13
 * Time: 14:34
 * @author Thomas Joußen <tjoussen@databay.de>
 */
class ilQuestionSetPoolSetsProvider extends ilPluginTableDatabaseDataProvider
{
    /**
     * @return string
     */
    protected function getSelectPart()
    {
        $select = array(
            "id",
            "title",
            "description"
        );

        $select[] = "(SELECT COUNT(qst.question_fi) FROM rep_robj_xqsp_qs_qst qst WHERE qst.questionset_fi = qs.id) has_questions";

        return implode(", ", $select);
    }

    /**
     * @return string
     */
    protected function getFromPart()
    {
        return "rep_robj_xqsp_qs qs";
    }

    /**
     * @return string
     */
    protected function getJoinPart()
    {
        return "";
    }

    /**
     * @param array $filter
     *
     * @return string
     */
    protected function getWherePart(array $filter)
    {
        return "questionsetpool_fi = " . $this->db->quote($filter["questionsetpool_fi"], "integer");
    }

    /**
     * @return string
     */
    protected function getGroupByPart()
    {
        return "";
    }

    /**
     * @param array $filter
     * @return string
     */
    protected function getHavingPart(array $filter)
    {
        return "";
    }

    /**
     * @param array $params
     * @return string
     */
    protected function getOrderByPart(array $params)
    {
        return "";
    }
}
