<?php

require_once "class.ilQuestionSetPoolQuestionsTableGUI.php";

/**
 * Class ilQuestionSetPoolSetQuestionsTableGUI
 *
 * Date: 16.01.14
 * Time: 12:08
 * @author Thomas Joußen <tjoussen@databay.de>
 */
class ilQuestionSetPoolSetQuestionsTableGUI extends ilQuestionSetPoolQuestionsTableGUI
{

    /**
     * Define a final formatting for a cell value
     *
     * @param mixed $column
     * @param array $row
     *
     * @return mixed
     */
    protected function formatCellValue($column, array $row)
    {
        if ($column == "tstamp" || $column == "created") {
            return ilDatePresentation::formatDate(new ilDateTime($row[$column], IL_CAL_UNIX));
        } elseif ($column == "type_tag") {
            return assQuestion::_getQuestionTypeName($row[$column]);
        } elseif ($column == "title") {
            $this->ctrl->setParameter($this->parent_obj, "q_id", $row["question_id"]);
            $row['title'] = '<a href="' . $this->ctrl->getLinkTarget($this->parent_obj, "ilQuestionSetPoolSetQuestionsGUI.editQuestion") . '" title="' . $this->plugin->txt('edit_question') . '">' . $row['title'] . '</a>';
            $this->ctrl->setParameter($this->parent_obj, "q_id", "");
        } elseif ($column == "actions" && !strlen($row[$column])) {
            $action = new ilAdvancedSelectionListGUI();
            $action->setId('asl_' . (int) $row["question_id"]);
            $action->setListTitle($this->lng->txt('actions'));

            $this->ctrl->setParameter($this->parent_obj, "q_id", $row["question_id"]);
            $action->addItem($this->plugin->txt('edit_question'), '', $this->ctrl->getLinkTarget($this->parent_obj, "ilQuestionSetPoolSetQuestionsGUI.editQuestion"));
            $action->addItem($this->lng->txt("preview"), '', $this->ctrl->getLinkTarget($this->parent_obj, "ilQuestionSetPoolSetQuestionsGUI.showQuestionPreview"));
            $action->addItem($this->lng->txt("delete"), '', $this->ctrl->getLinkTarget($this->parent_obj, "ilQuestionSetPoolSetQuestionsGUI.removeConfirmation"));
            $this->ctrl->setParameter($this->parent_obj, "q_id", "");

            $row["actions"] = $action->getHTML();
        }

        return $row[$column];
    }
}
